// Generic List Union
abstract class AList<T> {
    
    public String toString(){ return toString("             "); }
    abstract String toString(String acc);

}

// Represents an Empty List of T
class MtList<T> extends AList<T>{

   public MtList(){}

   String toString(String acc){ return acc+""; }
}


// Represents a Non-empty List of T
class ConsList<T> extends AList<T>{
    T first;
    AList<T> rest;

    // Basic Constructor
    public ConsList(T first, AList<T> rest){
        this.first = first;
        this.rest = rest;
    }

    String toString(String acc){ 
        return acc+first+", \n"+rest.toString(acc+"    ");
    }
}




